package it.zanichelli.android.esercizio17;

import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.TextView;
import android.widget.Toast;

public class MainActivity extends AppCompatActivity {
  private TextView input;

  @Override
  protected void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.activity_main);

    input = (TextView) findViewById(R.id.value);
  }

  public void onClick(View v)
  {
    Intent i = new Intent(this, ResultActivity.class);
    double in = 0, out = 0;
    // se a true la conversione è da km in miglia, falso altrimenti
    boolean isKmToMiles = true;

    try
    {
      in = Double.parseDouble(input.getText().toString());
    }
    catch (NumberFormatException nfe)
    {
      Toast.makeText(this, R.string.error, Toast.LENGTH_LONG).show();
      return;
    }

    switch(v.getId())
    {
      case R.id.km_to_miles:
        out = in * 0.621371192;

        break;
      case R.id.miles_to_km:
        out = in * 1.609344;
        isKmToMiles = false;
        break;
      default:
        return;
    }

    i.putExtra("In", in)
      .putExtra("Out", out)
      .putExtra("KmOrMiles", isKmToMiles);
    startActivity(i);
  }
}
