package it.zanichelli.android.esercizio18;

import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

public class MainActivity extends AppCompatActivity {
  private Calcolatrice calcolatrice = new Calcolatrice();
  String operando = "";
  private TextView prompt;

  // flag varie per la gestione dell'operando durante la digitazione
  private boolean virgola = false;
  private boolean actionset = false;
  private boolean uguale = false;

  @Override
  protected void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.activity_main);

    prompt = (TextView) findViewById(R.id.prompt);
  }

  public void Numero(View v) {
    Button b = (Button) v;
    char numero = b.getText().charAt(0);

    if (actionset) {
      operando = "";
      actionset = false;
    }

    if (virgola) {
      if (operando.length() == 0)
        operando = getString(R.string.zero);
      operando += ".";
      virgola = false;
    }

    if (operando.equals(getString(R.string.zero)))
      operando = "";

    operando += numero;
    calcolatrice.setOperando(Double.parseDouble(operando));
    prompt.setText(operando);
  }

  public void Virgola(View v) {
    if (actionset) {
      operando = getString(R.string.zero);
      actionset = false;
    }

    if (operando.contains("."))
      return;

    if (operando.length() == 0) {
      operando = getString(R.string.zero);
      calcolatrice.setOperando(0.0);
    }

    virgola = true;
    prompt.setText(operando + ".");
  }

  public void Clear(View v) {
    calcolatrice.cancella();
    operando = "";
    virgola = false;
    actionset = false;
    prompt.setText(getString(R.string.zero));
  }

  public void ClearOperand(View v) {
    calcolatrice.cancellaUltimoOperando();
    operando = getString(R.string.zero);
    virgola = false;
    prompt.setText(getString(R.string.zero));
  }

  public void Operazione(View v) {
    Button b = (Button) v;

    if (!uguale) {
      calcolatrice.uguale();
      prompt.setText(calcolatrice.risultato());
    }

    char operazione = b.getText().charAt(0);
    operazione = (operazione == 'x') ? '*' : operazione;

    calcolatrice.setOperazione(operazione);

    actionset = true;
    virgola = false;
    uguale = false;
  }

  public void Segno(View v) {
    if (actionset) {
      operando = "";
      actionset = false;
      return;
    }

    if (operando.length() < 1 || Double.parseDouble(operando) == 0)
      return;

    if (operando.charAt(0) == '-')
      operando = operando.substring(1, operando.length()).toString();
    else
      operando = '-' + operando;

    calcolatrice.cambiaSegno();
    prompt.setText(operando);
  }

  public void Uguale(View v) {
    calcolatrice.setOperando(Double.parseDouble(operando));
    calcolatrice.uguale();
    prompt.setText(calcolatrice.risultato());
    actionset = true;
    uguale = true;
    virgola = false;
  }
}
