package it.zanichelli.android.esercizio21;

import android.os.AsyncTask;

/**
 * Created by Gabriele Ara on 19/03/2017.
 */

public class EuroConverterAsync {

  public static void requestEuroConverter(String currency, OnEuroConveterListener listener) {
    EuroConverterTask task = new EuroConverterTask(listener);
    task.execute(currency);
  }
}

class EuroConverterTask extends AsyncTask<String, Void, Float> {
  private OnEuroConveterListener listener;
  private EuroConverter converter;

  public EuroConverterTask(OnEuroConveterListener listener) {
    super();
    this.listener = listener;
    this.converter = null;
  }

  @Override
  protected void onPreExecute() {
    listener.onEuroConverterStart();
  }


  @Override
  protected Float doInBackground(String... strings) {
    EuroConverter euroconverter = new EuroConverter(strings[0]);

    euroconverter.askRate();

    return euroconverter.getRate();
  }

  @Override
  protected void onPostExecute(Float result) {
    listener.onEuroConverterResult(result);
  }
}