package com.zanichelli.android.registrazione;

import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.Gravity;
import android.widget.*;

public class SignActivity extends AppCompatActivity {

  @Override
  protected void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);

    // creazione e inizializzazione dei componenti
    TextView usernameText = new TextView(this);
    usernameText.setText(getString(R.string.username));
    EditText usernameEdit = new EditText(this);
    TextView passwordText = new TextView(this);
    passwordText.setText(getString(R.string.password));
    EditText passwordEdit = new EditText(this);
    TextView rePasswordText = new TextView(this);
    rePasswordText.setText(getString(R.string.repassword));
    EditText rePasswordEdit = new EditText(this);
    TextView gender = new TextView(this);
    gender.setText(getString(R.string.gender));
    RadioButton male = new RadioButton(this);
    male.setText(getString(R.string.male));
    RadioButton female = new RadioButton(this);
    female.setText(getString(R.string.female));

    // raggruppamento dei radio-button
    RadioGroup radioGroup = new RadioGroup(this);
    radioGroup.setOrientation(LinearLayout.HORIZONTAL);
    radioGroup.addView(male);
    radioGroup.addView(female);
    Button save = new Button(this);
    save.setText(getString(R.string.save));
    Button cancel = new Button(this);
    cancel.setText(getString(R.string.cancel));

    // disposizione degli oggetti su più TableRow
    TableRow firstRow = new TableRow(this);
    firstRow.addView(usernameText);
    firstRow.addView(usernameEdit);
    TableRow secondRow = new TableRow(this);
    secondRow.addView(passwordText);
    secondRow.addView(passwordEdit);
    TableRow thirdRow = new TableRow(this);
    thirdRow.addView(rePasswordText);
    thirdRow.addView(rePasswordEdit);
    TableRow fourthRow = new TableRow(this);
    fourthRow.addView(gender);
    fourthRow.addView(radioGroup);

    // inserimento delle righe nella tabella
    TableLayout tableLayout = new TableLayout(this);
    tableLayout.setColumnStretchable(1, true);
    tableLayout.addView(firstRow);
    tableLayout.addView(secondRow);
    tableLayout.addView(thirdRow);
    tableLayout.addView(fourthRow);

    // disposizione orizzontale dei pulsanti
    LinearLayout innerLinearLayout = new LinearLayout(this);
    innerLinearLayout.setOrientation(LinearLayout.HORIZONTAL);
    innerLinearLayout.setGravity(Gravity.CENTER_HORIZONTAL);
    innerLinearLayout.addView(save);
    innerLinearLayout.addView(cancel);

    // conversione del padding da dp a px
    float scale = getResources().getDisplayMetrics().density;
    int paddingPixels = (int) (16 * scale + 0.5f);

    // inserimento in verticale dei layout
    LinearLayout outerLinearLayout = new LinearLayout(this);
    outerLinearLayout.setOrientation(LinearLayout.VERTICAL);
    outerLinearLayout.setPadding(paddingPixels,
      paddingPixels, paddingPixels, paddingPixels);
    outerLinearLayout.addView(tableLayout);
    outerLinearLayout.addView(innerLinearLayout);

    // impostazione dell’interfacia utente
    setContentView(outerLinearLayout);
  }
}

