package com.zanichelli.android.cronometro;

/**
 * Created by Gabriele on 23/11/2016.
 */

import android.app.Application;
import android.content.SharedPreferences;
import android.preference.PreferenceManager;

public class ChronometerApplication extends Application {
  private ChronometerData chronometer;
  private int defaultPrecision;
  private SharedPreferences sharedPreferences;

  public ChronometerApplication() {
    super();
    chronometer = new ChronometerData();
  }

  // restituisce l'oggetto cronometro
  public ChronometerData getChronometerData() {
    return chronometer;
  }

  // metodo usato per aggiornare la precisione,
  // ogni volta che viene invocato salva nel file
  // delle preferenze il valore ricevuto in ingresso
  public void setChronometerPrecision(int precision) {
    chronometer.setPrecision(precision);
    SharedPreferences.Editor editor =
      sharedPreferences.edit();
    editor.putInt(
      getString(R.string.pref_precision_key), precision);
    editor.apply();
  }

  // all'avvio, la APP recupera il valore
  // precedentemente salvato (se presente)
  // oppure imposta la precisione al suo
  // valore predefinito
  @Override
  public void onCreate() {
    super.onCreate();

    sharedPreferences = PreferenceManager
      .getDefaultSharedPreferences(this);
    defaultPrecision = getResources()
      .getInteger(R.integer.pref_precision_default);

    int savedPrecision = sharedPreferences.getInt(
      getString(R.string.pref_precision_key),
      defaultPrecision
    );

    chronometer.setPrecision(savedPrecision);
  }

}
