package com.zanichelli.android.cronometro;

import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.Gravity;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.TextView;
import com.zanichelli.android.cronometro.ChronometerData.LapData;

public class LapsActivity extends AppCompatActivity {
  // crea una riga a partire dai dati di un giro
  private View createView(LapData data) {
    String num = Integer.toString(data.lap_num);
    String time = ChronometerData.format(data.lap_time);
    String duration = ChronometerData.format(data.lap_duration);
    return createViewFromStrings(num, time, duration);
  }

  // crea una riga contenente tre colonne, contentnti rispettivamente il numero,
  // il valore e la durata del giro registrato
  private View createViewFromStrings(String num, String time, String duration) {
    LinearLayout.LayoutParams par = new LinearLayout.LayoutParams(
      LinearLayout.LayoutParams.MATCH_PARENT,
      (int) getResources().getDimension(R.dimen.big_text_size));

    LinearLayout l = new LinearLayout(this);
    l.setOrientation(LinearLayout.HORIZONTAL);
    l.setLayoutParams(par);

    par = new LinearLayout.LayoutParams(
      LinearLayout.LayoutParams.MATCH_PARENT,
      LinearLayout.LayoutParams.MATCH_PARENT,
      1f);

    TextView text_num = new TextView(this);
    text_num.setGravity(Gravity.CENTER_VERTICAL);
    text_num.setText(num);
    text_num.setLayoutParams(par);

    TextView text_time = new TextView(this);
    text_time.setGravity(Gravity.CENTER_VERTICAL);
    text_time.setText(time);
    text_time.setLayoutParams(par);

    TextView text_duration = new TextView(this);
    text_duration.setGravity(Gravity.CENTER_VERTICAL);
    text_duration.setText(duration);
    text_duration.setLayoutParams(par);

    l.addView(text_num);
    l.addView(text_time);
    l.addView(text_duration);

    return l;
  }

  @Override
  protected void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.activity_laps);

    ChronometerApplication app = (ChronometerApplication) getApplication();
    ChronometerData chronometer = app.getChronometerData();

    LapData[] lapsData = chronometer.getLapsData();
    LinearLayout listContainer = (LinearLayout) findViewById(R.id.laps_list);

    for(int i = 0; i < lapsData.length; ++i)
      listContainer.addView(createView(lapsData[i]));

  }
}
